/*=========================================================

	cdialog/message.h

	bZ[W_CAOB

=========================================================*/
#ifndef CDIALOG_MESSAGE_H
#define CDIALOG_MESSAGE_H

#include "dev.h"

/*=========================================================
	萔
=========================================================*/
#define CDIALOG_MESSAGE_TITLE_LENGTH 32
#define CDIALOG_MESSAGE_LENGTH       512

#define CDIALOG_MESSAGE_ANS_YESNO "[" PB_SYM_PSP_CIRCLE "]" CDIALOG_STR_MESSAGE_YES " [" PB_SYM_PSP_CROSS "]" CDIALOG_STR_MESSAGE_NO
#define CDIALOG_MESSAGE_ANS_OK    "[" PB_SYM_PSP_CIRCLE "]" CDIALOG_STR_MESSAGE_OK

#ifdef __cplusplus
extern "C" {
#endif

/*=========================================================
	^錾
=========================================================*/
typedef enum {
	CDIALOG_MESSAGE_YESNO = 0x00000001,
} CdialogMessageOptions;

typedef struct {
	char title[CDIALOG_MESSAGE_TITLE_LENGTH];
	unsigned int options;
	char message[CDIALOG_MESSAGE_LENGTH];
} CdialogMessageData;

typedef struct {
	bool destroySelf;
	struct cdialog_dev_base_params base;
	CdialogMessageData data;
} CdialogMessageParams;

/*=========================================================
	֐
=========================================================*/
int cdialogMessageInit( CdialogMessageParams *params );
CdialogMessageData *cdialogMessageGetData( void );
CdialogStatus cdialogMessageGetStatus( void );
CdialogResult cdialogMessageGetResult( void );
int cdialogMessageStart( unsigned short x, unsigned short y );
int cdialogMessageStartNoLock( unsigned short x, unsigned short y );
int cdialogMessageUpdate( void );
int cdialogMessageShutdownStartNoLock( void );
int cdialogMessageShutdownStart( void );
void cdialogMessageDestroy( void );

#ifdef __cplusplus
}
#endif

#endif
